#pragma once

#include "ofMain.h"
#include "attractor.h"
#include "line.h"

class Particle
{

public:

	Particle();
	~Particle();

	void setup(ofVec2f position);

	void update(float deltaT, vector<Attractor*>* attractors);

	void draw();

	float getAgeNorm();
	float getMaxLife();


private:

	int counterOfActiveAttractors;

	ofVec2f vel;
	ofVec2f position;

	float maxLife;
	float age;

	float size;
	float mass;

	int blobCounterInParticle;

	ofColor color;
	ofImage tex;
};
