//
//  particleSystem.hpp
//  emptyExample
//
//  Created by Sebastian Holzki on 16.04.19.
//
#pragma once


#include <stdio.h>

#include "ofxXmlSettings.h"
#include "particle.hpp"

#include "objectPhysics.hpp"
#include "checkedInVisitor.hpp"

//class Line will be used to draw the polymesh

class Line {
    
public:
    
    Line();
    Line(ofPoint p1, ofPoint p2){
        point1 = p1;
        point2= p2;
    };
    ~Line();
    
    ofPoint point1;
    ofPoint point2;
    
};



class ParticleSystem {
    
  
    
public:
    
    ParticleSystem();
    ~ParticleSystem();
    
    
  void setup();
  void update(float deltaT, particleMode mode, vector<ObjectPhysics*>* objectPhysics, vector<CheckedInVisitor*>* checkedInVisitors, float sceneWidth, float sceneHeight);
  void draw(typeOfView activeTypeOfView);
    
    
    void updateLines(particleMode currentMode, vector<ObjectPhysics*>* objectPhysics);
    

    particleMode currentMode;
    
    ofxXmlSettings xmlParticleSystems;
    ofxXmlSettings xmlParticles;        // ??? wo soll das hin ???
    
   vector<Particle*> particles;
    
    vector<Line*> lines;
    
    
    
private:
    
    
    int playerType;
    //Global for particleSystems-birthrate -> can be used to emit faster/slower
    
    int PARTICLESYSTEM_BIRTHRATE;
    int PRODUCED_PER_EMITTER;
    
    
    
   
    
};





